<?php

declare(strict_types=1);

namespace Drupal\workspace_approval\Routing;

use Drupal\Core\Entity\EntityTypeInterface;
use Drupal\Core\Entity\Routing\AdminHtmlRouteProvider;
use Drupal\workspace_approval\Controller\WorkspaceApprovalRequestController;
use Symfony\Component\Routing\Route;

/**
 * Overrides the workspace_approval_request add-page and add-form routes.
 */
final class WorkspaceApprovalRequestHtmlRouteProvider extends AdminHtmlRouteProvider {

  /**
   * {@inheritdoc}
   */
  protected function getAddPageRoute(EntityTypeInterface $entity_type): ?Route {
    $route = parent::getAddPageRoute($entity_type);
    if ($route instanceof Route) {
      $route->setDefault('_controller', WorkspaceApprovalRequestController::class . '::addPage');
    }
    return $route;
  }

  /**
   * {@inheritdoc}
   */
  protected function getAddFormRoute(EntityTypeInterface $entity_type): ?Route {
    $route = parent::getAddFormRoute($entity_type);
    if ($route instanceof Route) {
      $route->setDefault('_title_callback', WorkspaceApprovalRequestController::class . '::addBundleTitle');
      $route->setOption('parameters', [
        ...$route->getOption('parameters'),
        ...[
          'workspace' => [
            'type' => 'entity:workspace',
          ],
        ],
      ]);
    }
    return $route;
  }

}
