<?php

declare(strict_types=1);

namespace Drupal\workspace_approval;

use Drupal\Core\Entity\Query\QueryInterface;
use Drupal\workspaces\WorkspaceInterface;

/**
 * Provides a list builder for the workspace approval request entity type.
 */
final class WorkspaceApprovalRequestListBuilder extends WorkspaceApprovalRequestListBuilderBase {

  /**
   * {@inheritdoc}
   */
  protected function getEntityListQuery(): QueryInterface {
    $query = parent::getEntityListQuery();
    $workspace = $this->routeMatch->getParameter('workspace');
    \assert($workspace instanceof WorkspaceInterface);
    $query->condition('subject', $workspace->id());
    return $query;
  }

}
