<?php

declare(strict_types=1);

namespace Drupal\workspace_approval;

use Drupal\Core\Entity\EntityListBuilderInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\StringTranslation\TranslatableMarkup;

/**
 * Interface for a list builder that builds a listing for a reviewer.
 */
interface WorkspaceApprovalRequestReviewerListBuilderInterface extends EntityListBuilderInterface {

  /**
   * Sets the user for whom the listing should be built.
   *
   * @param \Drupal\Core\Session\AccountInterface $reviewer
   *   The account object.
   */
  public function setReviewer(AccountInterface $reviewer): void;

  /**
   * Gets the listing page title.
   *
   * @return \Drupal\Core\StringTranslation\TranslatableMarkup|string
   *   The title.
   */
  public function getTitle(): TranslatableMarkup|string;

}
