<?php

declare(strict_types=1);

namespace Drupal\workspace_approval;

use Drupal\Core\Entity\ContentEntityStorageInterface;

/**
 * Defines the interface for the workspace approval request storage handler.
 */
interface WorkspaceApprovalRequestStorageInterface extends ContentEntityStorageInterface {

  /**
   * Helper to retrieve workspace_approval_request entities.
   *
   * @param ?string $transition_id
   *   Transition to search.
   * @param ?string $subject_id
   *   ID of the workspace_approval_request subject entity to search.
   *
   * @return array
   *   Set of workspace_approval_request entities found.
   */
  public function getApprovalRequests(?string $transition_id = NULL, ?string $subject_id = NULL): array;

}
